; h8/300 and h8/300h start up file.

;#ifdef __H8300H__

	.h8300h
	.section .text
	.global	_start
  .global _FuncPtr

_start:
  jmp @initram
  jmp @_main
_reconcode:
  .long 0x29a7e520
_FuncPtr:
  .long 0x00000200

initram:
;  mov.l #_stack,sp  No stack init, use H8 stack space

  mov.l #_data,er0
	mov.l	#_end,er1
  mov.w #0,r2                ; not sure about alignment requirements
.loop1:                      ; playing it safe for now
  mov.w r2,@er0              ; zero out the edata segment
	adds	#2,er0
	cmp.l	er1,er0
  blo .loop1

  mov.l #_etext,er0          ; source start
  mov.l #_data,er1           ; target start
  mov.l #_edata,er2          ; target end
  cmp.l er1,er2              ; something to copy
  beq .loop3
.loop2:
  mov.b @er0,r3l             ; copy init data
  mov.b r3l,@er1
  adds  #1,er0
  adds  #1,er1
  cmp.l er2,er1
  blo .loop2
.loop3:

  rts

; No stack, use H8 stack space
  .section .stack
_stack: .long   1

;#endif

